## ros-one-bio-ik 1.0.0-117jammy.20251023.1526

=== debian/changelog ===
ros-one-bio-ik (1.0.0-117jammy.20251023.1526) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Philipp Sebastian Ruppel <0ruppel@informatik.uni-hamburg.de>  Thu, 23 Oct 2025 15:26:13 +0000

ros-one-bio-ik (1.0.0-0jammy) jammy; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Philipp Sebastian Ruppel <0ruppel@informatik.uni-hamburg.de>  Thu, 23 Oct 2025 15:26:13 -0000

## ros-one-bio-ik 1.0.0-117jammy.20251208.0827

=== debian/changelog ===
ros-one-bio-ik (1.0.0-117jammy.20251208.0827) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Philipp Sebastian Ruppel <0ruppel@informatik.uni-hamburg.de>  Mon, 08 Dec 2025 08:27:27 +0000

## ros-one-bio-ik 1.0.0-117jammy.20260128.2157

=== debian/changelog ===
ros-one-bio-ik (1.0.0-117jammy.20260128.2157) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Philipp Sebastian Ruppel <0ruppel@informatik.uni-hamburg.de>  Wed, 28 Jan 2026 21:57:25 +0000

## ros-one-bio-ik 1.0.0-117jammy.20260301.2146

=== debian/changelog ===
ros-one-bio-ik (1.0.0-117jammy.20260301.2146) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Philipp Sebastian Ruppel <0ruppel@informatik.uni-hamburg.de>  Sun, 01 Mar 2026 21:46:50 +0000

## ros-one-bio-ik 1.0.0-117noble.20251023.1601

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(bio_ik)

if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  message("${PROJECT_NAME}: You did not request a specific build type: Choosing 'Release' for maximum performance")
  set(CMAKE_BUILD_TYPE Release)
endif()

find_package(catkin REQUIRED COMPONENTS
  eigen_conversions
  moveit_core
  moveit_ros_planning
  pluginlib
  roscpp
  tf2
  tf2_eigen
  tf2_kdl
  tf2_geometry_msgs
  tf_conversions
)

find_package(OpenMP)
# the specific flag is not yet present in cmake 2.8.12
if(OpenMP_CXX_FOUND OR OPENMP_FOUND)
  message(STATUS "OPENMP FOUND")
  add_compile_options(${OpenMP_CXX_FLAGS})
  if(NOT OpenMP_CXX_LIBRARIES)
    # cmake 2.8.12 does not yet specify the library - assume we might need libgomp
    set(OpenMP_LIBS gomp)
  else()
    set(OpenMP_LIBS ${OpenMP_CXX_LIBRARIES})
  endif()
else()
    message(WARNING "OPENMP NOT FOUND. You will suffer performance loss.")
    set(OpenMP_LIBS)
endif()

option(USE_FANN "build the neural-network-based IK solver (experimental)" OFF)
if(USE_FANN)
    find_library(FANN_LIBRARIES NAMES fann)
    find_path(FANN_INCLUDE_DIRS NAMES fann.h)
    if(NOT FANN_INCLUDE_DIRS OR NOT FANN_LIBRARIES)
        message(FATAL_ERROR "Neural network solver requested, but libfann was not found.")
    else()
        message("Found libfann: ${FANN_LIBRARIES} / ${FANN_INCLUDE_DIRS}")
    endif()
else()
    set(FANN_LIBRARIES)
    set(FANN_INCLUDE_DIRS)
endif()

option(USE_CPPOPTLIB "Include gradient-based solvers from CppNumericalSolvers (bio_ik also provides its own solver)" OFF)
if(USE_CPPOPTLIB)
    find_path(CPPOPTLIB_INCLUDE_DIRS
        NAMES cppoptlib/solver/bfgssolver.h
        HINTS ../../CppNumericalSolvers/include)
    if(NOT CPPOPTLIB_INCLUDE_DIRS)
        message(FATAL_ERROR "cppoptlib support requested, but the headers could not be found.")
    else()
        message("Found cppoptlib: ${CPPOPTLIB_INCLUDE_DIRS}")
    endif()
    add_definitions(-DENABLE_CPP_OPTLIB)
else()
    set(CPPOPTLIB_INCLUDE_DIRS)
endif()

catkin_package(
    INCLUDE_DIRS include
    LIBRARIES ${PROJECT_NAME}
    CATKIN_DEPENDS
        eigen_conversions
        moveit_core
        moveit_ros_planning
        pluginlib
        roscpp
        tf2
        tf2_kdl
        tf2_geometry_msgs
)

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  add_compile_options(-frecord-gcc-switches)
endif()

add_compile_options($<$<CONFIG:Release>:-O3>)
add_compile_options($<$<CONFIG:Release>:-ftree-vectorize>)
add_compile_options($<$<CONFIG:Release>:-ffast-math>)
add_compile_options($<$<CONFIG:Release>:-fno-finite-math-only>)

include_directories(
    include
    ${FANN_INCLUDE_DIRS}
    ${CPPOPTLIB_INCLUDE_DIRS}
    ${catkin_INCLUDE_DIRS}
)

set(SOURCES
    src/goal_types.cpp
    src/kinematics_plugin.cpp
    src/problem.cpp

    src/ik_test.cpp
    src/ik_gradient.cpp
    src/ik_evolution_1.cpp
    src/ik_evolution_2.cpp
)

if(USE_FANN)
    list(APPEND SOURCES src/ik_neural.cpp)
endif()

if(USE_CPPOPTLIB)
    list(APPEND SOURCES src/ik_cppoptlib.cpp)
endif()

add_library(${PROJECT_NAME} ${SOURCES})

set_target_properties(${MOVEIT_LIB_NAME} PROPERTIES VERSION ${${PROJECT_NAME}_VERSION})

add_dependencies(${PROJECT_NAME} ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})

target_link_libraries(${PROJECT_NAME}
  ${catkin_LIBRARIES}
  ${FANN_LIBRARIES}
  ${OpenMP_LIBS}

  -static-libgcc
  -static-libstdc++
)

install(DIRECTORY include/${PROJECT_NAME}/ DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})

install(FILES bio_ik_kinematics_description.xml DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

=== debian/changelog ===
ros-one-bio-ik (1.0.0-117noble.20251023.1601) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Philipp Sebastian Ruppel <0ruppel@informatik.uni-hamburg.de>  Thu, 23 Oct 2025 16:01:43 +0000

ros-one-bio-ik (1.0.0-0noble) noble; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Philipp Sebastian Ruppel <0ruppel@informatik.uni-hamburg.de>  Thu, 23 Oct 2025 16:01:43 -0000

=== debian/control ===
Source: ros-one-bio-ik
Section: misc
Priority: optional
Maintainer: Philipp Sebastian Ruppel <0ruppel@informatik.uni-hamburg.de>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, ros-one-catkin, ros-one-eigen-conversions, ros-one-moveit-core, ros-one-moveit-ros-planning, ros-one-pluginlib, ros-one-roscpp, ros-one-tf-conversions, ros-one-tf2, ros-one-tf2-eigen, ros-one-tf2-geometry-msgs, ros-one-tf2-kdl
Homepage: 
Standards-Version: 3.9.2

Package: ros-one-bio-ik
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, ros-one-eigen-conversions, ros-one-moveit-core, ros-one-moveit-ros-planning, ros-one-pluginlib, ros-one-roscpp, ros-one-tf-conversions, ros-one-tf2, ros-one-tf2-eigen, ros-one-tf2-geometry-msgs, ros-one-tf2-kdl
Description: BioIK for ROS

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-bio-ik//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-bio-ik 1.0.0-117noble.20251208.1500

=== debian/changelog ===
ros-one-bio-ik (1.0.0-117noble.20251208.1500) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Philipp Sebastian Ruppel <0ruppel@informatik.uni-hamburg.de>  Mon, 08 Dec 2025 15:00:44 +0000

## ros-one-bio-ik 1.0.0-117noble.20260128.2205

=== debian/changelog ===
ros-one-bio-ik (1.0.0-117noble.20260128.2205) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Philipp Sebastian Ruppel <0ruppel@informatik.uni-hamburg.de>  Wed, 28 Jan 2026 22:05:30 +0000

## ros-one-bio-ik 1.0.0-117noble.20260301.2142

=== debian/changelog ===
ros-one-bio-ik (1.0.0-117noble.20260301.2142) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Philipp Sebastian Ruppel <0ruppel@informatik.uni-hamburg.de>  Sun, 01 Mar 2026 21:42:20 +0000
